unit edtpass;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Data;

type
  TEditPass = class(TForm)
    cmbConnect: TComboBox;
    edtUser: TEdit;
    edtPassw: TEdit;
    btnOK: TBitBtn;
    btnCancel: TBitBtn;
    lblServer: TLabel;
    lblLogin: TLabel;
    lblPassw: TLabel;
    procedure btnOKClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure edtPasswChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

function EditPass(var R:TPass) : boolean;

implementation

uses main;

function EditPass(var R:TPass) : boolean;
var
  i : integer;
begin
  with TEditPass.Create(nil) do
  begin
    if Trim(R.Password)<>'' then edtPassw.PasswordChar := '*';
    edtPassw.Text := R.Password;
    edtUser.Text    := R.username;
    cmbConnect.Text := R.Connect;
    for i := 0 to MainForm.PassList.Count-1 do
    begin
      if cmbConnect.Items.IndexOf(TPPass(MainForm.PassList[i]).connect)<0
      then cmbConnect.Items.Add(TPPass(MainForm.PassList[i]).connect);
    end;
    Result := ShowModal = mrOK;
    if Result then
    begin
      R.Username := Trim(edtUser.Text);
      R.Password := Trim(edtPassw.Text);
      R.Connect  := cmbConnect.Text;
    end;
    Free;
  end;
end;

{$R *.DFM}

procedure TEditPass.btnOKClick(Sender: TObject);
begin
  if cmbConnect.Text='' then
  begin
    if MainForm.RusLang
    then MessageDlg('  ',mtError,[mbOk],0)
    else MessageDlg('Server can''t be empty',mtError,[mbOk],0);
    Exit;
  end;
  if edtUser.Text='' then
  begin
    if MainForm.RusLang
    then MessageDlg('  ',mtError,[mbOk],0)
    else MessageDlg('Login can''t be empty',mtError,[mbOk],0);
    Exit;
  end;
  if edtPassw.Text='' then
  begin
    if MainForm.RusLang
    then MessageDlg('  ',mtError,[mbOk],0)
    else MessageDlg('Password can''t be empty',mtError,[mbOk],0);
    Exit;
  end;
  ModalResult := mrOk;
end;

procedure TEditPass.FormShow(Sender: TObject);
begin
  if Trim(edtPassw.Text)='' then edtPassw.SetFocus;
  if Trim(edtUser.Text)='' then edtUser.SetFocus;
  if Trim(cmbConnect.Text)='' then cmbConnect.SetFocus;
  if MainForm.RusLang then
  begin
    Caption           := ' ';
    lblServer.Caption := '';
    lblLogin.Caption  := '';
    lblPassw.Caption  := '';
    btnOK.Caption     := 'OK';
    btnCancel.Caption := '';
  end else
  begin
    Caption           := 'Enter login';
    lblServer.Caption := 'Server';
    lblLogin.Caption  := 'Login';
    lblPassw.Caption  := 'Password';
    btnOK.Caption     := 'OK';
    btnCancel.Caption := 'Cancel';
  end;
end;

procedure TEditPass.edtPasswChange(Sender: TObject);
begin
  if TEdit(Sender).Text='' then TEdit(Sender).PasswordChar := #0;
end;

end.
