unit wndedit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids,Data, StdCtrls, Buttons, ExtCtrls;

type
  TWindEdit = class(TForm)
    btnSave: TBitBtn;
    btnCancel: TBitBtn;
    edtTitle: TEdit;
    lblTitle: TLabel;
    cmbLogin: TComboBox;
    cmbPass: TComboBox;
    cmbServer: TComboBox;
    cmbOk: TComboBox;
    lblLogin: TLabel;
    lblPass: TLabel;
    lblServer: TLabel;
    lblOK: TLabel;
    procedure FormShow(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
  public
    HW         : integer;
    WndList    : TWindowList;
    LoginWnd   : TLoginWindow;
  end;

function EditWindow(H:integer; var W:TLoginWindow) : boolean;

implementation

{$R *.DFM}

function EditWindow(H:integer; var W:TLoginWindow) : boolean;
var
  Buf : array[1..500] of char;
  s : string;
begin
  with TWindEdit.Create(nil) do
  begin
    WndList := TWindowList.Create;
    WndList.Fill(H);
    HW := H;

    Buf[1] := #0;
    GetClassName(HW,@Buf[1],500);
    LoginWnd.ClassName := StrPas(@Buf[1]);

    Buf[1] := #0;
    SendMessage(HW,WM_GETTEXT,499,integer(@Buf[1]));
    s := Trim(StrPas(@Buf[1]));
    LoginWnd.Name := LoginWnd.ClassName;
    if s<>'' then LoginWnd.Name := LoginWnd.Name + ' : ' + s;

    Result := ShowModal=mrOK;
    if Result then W := LoginWnd;
    WndList.Free;
    Free;
  end;
end;

procedure TWindEdit.FormShow(Sender: TObject);
var
  i : integer;
  s : string;
  RusLang : boolean;
begin
  RusLang := (GetUserDefaultLangID mod 256)=LANG_RUSSIAN;
  if RusLang then
  begin
    Caption            := ' ';
    btnCancel.Caption  := '';
    lblTitle.Caption   := '';
    lblServer.Caption  := '';
    lblLogin.Caption   := '';
    lblPass.Caption    := '';
    lblOK.Caption      := ' OK';
  end;

  edtTitle.Text := LoginWnd.Name;

  for i:=0 to WndList.Count-1 do
  begin
    s := ' '+TPWindow(WndList[i])^.ClassName;
    if TPWindow(WndList[i])^.Text<>''
    then s := s + ' - '+TPWindow(WndList[i])^.Text;
    s := s + ' (X:'+IntToStr(TPWindow(WndList[i])^.X)+',Y:'+IntToStr(TPWindow(WndList[i])^.Y)+')';
    cmbServer.Items.Add(s);
    cmbLogin.Items.Add(s);
    cmbPass.Items.Add(s);
    cmbOk.Items.Add(s);
  end;
end;

procedure TWindEdit.btnSaveClick(Sender: TObject);

var lc : TLoginWindowControl;

procedure FillControl(W:TWindow; var C : TLoginControl);
begin
  C.ClassName := W.ClassName;
  C.Text      := W.Text;
  C.PosX      := W.PosX;
  C.PosY      := W.PosY;
end;

begin
  for lc := Low(TLoginWindowControl) to High(TLoginWindowControl) do
  FillChar(LoginWnd.Controls[lc],SizeOf(TLoginWindowControl),0);

  LoginWnd.Name := Trim(edtTitle.Text);

  if cmbServer.ItemIndex>=0 then
  FillControl(TPWindow(WndList[cmbServer.ItemIndex])^,LoginWnd.Controls[Server]);
  if cmbLogin.ItemIndex>=0 then
  FillControl(TPWindow(WndList[cmbLogin.ItemIndex])^,LoginWnd.Controls[Login]);
  if cmbPass.ItemIndex>=0 then
  FillControl(TPWindow(WndList[cmbPass.ItemIndex])^,LoginWnd.Controls[Password]);
  if cmbOK.ItemIndex>=0 then
  FillControl(TPWindow(WndList[cmbOK.ItemIndex])^,LoginWnd.Controls[Connect]);

  for lc := Low(TLoginWindowControl) to High(TLoginWindowControl) do
  if lc<>Connect then LoginWnd.Controls[lc].Text := '';
end;

end.
