unit wndlist;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids,Data, StdCtrls, Buttons, ExtCtrls;

type
  TWindList = class(TForm)
    Grid: TStringGrid;
    Panel1: TPanel;
    lblClass: TLabel;
    Panel2: TPanel;
    lblCaption: TLabel;
    btnSave: TBitBtn;
    btnCancel: TBitBtn;
    procedure ShowWindows;
    procedure FormShow(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
  public
    WndHnd : integer;
    WindowList : TWindowList;
  end;

function SelectWindow(ParentHWND:integer) : integer;

implementation

{$R *.DFM}

type TIntPtr = ^integer;

function EnumWindowChild(WinHandle: HWnd; Param: LongInt): Boolean; stdcall;
begin
  Result := true;
  inc(TIntPtr(Param)^);
end;

function EnumWindowProc(WinHandle: HWnd; Param: LongInt): Boolean; stdcall;
var
  i : integer;
  W : TWindow;
  R : TRect;
  Buf : array[1..500] of char;
begin
  Result := true;

  if not IsWindowVisible(WinHandle) then Exit;

  i := 0;
  EnumChildWindows(WinHandle,@EnumWindowChild,Integer(@i));
  if i<3 then Exit;

  FillChar(W,SizeOf(TWindow),0);
  W.Kind := -1;

  W.hWnd := WinHandle;

  Buf[1] := #0;
  SendMessage(WinHandle,WM_GETTEXT,499,integer(@Buf[1]));
  W.Text := Trim(StrPas(@Buf[1]));

  Buf[1] := #0;
  i := GetClassName(WinHandle,@Buf[1],500);
  if i>0 then W.ClassName := StrPas(@Buf[1]);

  GetWindowRect(WinHandle,R);
  W.X := R.Left;
  W.Y := R.Top;

  TWindowList(Param).AddWindow(W);
end;


function SelectWindow(ParentHWND:integer) : integer;
begin
  Result := 0;
  with TWindList.Create(nil) do
  begin
    WndHnd := 0;
    WindowList := TWindowList.Create;
    if ParentHWND=0
    then EnumWindows(@EnumWindowProc,Integer(WindowList))
    else EnumChildWindows(ParentHWND,@EnumWindowProc,Integer(WindowList));
    if ShowModal = mrOK then Result := WndHnd;
    WindowList.Free;
    Free;
  end;
end;

procedure TWindList.ShowWindows;
var i : integer;
begin
  for i:=0 to Grid.RowCount-1 do
  begin
    Grid.Cells[0,i] := '';
    Grid.Cells[1,i] := '';
  end;
  Grid.RowCount := WindowList.Count;
  for i:=0 to WindowList.Count-1 do
  begin
    Grid.Cells[0,i] := ' '+TPWindow(WindowList[i])^.ClassName;
    Grid.Cells[1,i] := ' '+TPWindow(WindowList[i])^.Text;
  end;
end;

procedure TWindList.FormShow(Sender: TObject);
var RusLang : boolean;
begin
  RusLang := (GetUserDefaultLangID mod 256)=LANG_RUSSIAN;
  if RusLang then
  begin
    Caption            := ' ';
    lblCaption.Caption := '';
    lblClass.Caption   := '';
    btnCancel.Caption  := '';
  end;
  ShowWindows;
end;

procedure TWindList.btnSaveClick(Sender: TObject);
begin
  WndHnd := TPWindow(WindowList[Grid.Row])^.hWnd;
end;

end.
